/*
 * control screen routines with escape sequences < escs.h >
 *
 * ץ󥹤ˤ롼
 *
 * Copyright (c) 1992-1994 Taiji Yamada, Tokyo Denki University
 * Copyright (c) 1998 Taiji Yamada, AIHARA Electrical Engineering Co.,Ltd.
 */
#ifndef _ESCS_H_
#define _ESCS_H_

/* ɽ֤ locate */
static void locate(int x, int y)
{
  printf("\x1b[%d;%dH", y, x);
}

/* ɽ() locate row */
static void locatex(int x)
{
  printf("\x1b[;%dH", x);
}

/* ɽ() locate column */
static void locatey(int y)
{
  printf("\x1b[%dH", y);
}

/* ̤ξõ clear screen */
static void cls(void)
{
  printf("\x1b[2J");
}

/* 뤫ޤǾõ clear to end of line */
static void cleol(void)
{
  printf("\x1b[K");
}

/* 뤫饹꡼νޤǾõ clear to end of screen */
static void cleos(void)
{
  printf("\x1b[0J");
}

/* ԤΤϤᤫ饫ޤǾõ clear from top of line */
static void cltol(void)
{
  printf("\x1b[1K");
}

/* ꡼ΤϤᤫ饫ޤǾõ clear from top of screen */
static void cltos(void)
{
  printf("\x1b[1J");
}

/* Ԥκ clear line */
static void cll(void)
{
  printf("\x1b[2K");
}

/* Ԥ insert line */
static void inl(int n)
{
  printf("\x1b[%dL", n);
}

/* ɽɽ set cursor on or off */
static void cursor(int on_off)
{
  if (on_off)
    printf("\x1b[>51");
  else
    printf("\x1b[>5h");
}

/*
 * 0: 
 * 1: ϥ饤
 * 2: С饤
 * 3: 
 * 4: 饤
 * 5: ֥
 * 6: 
 * 7: С
 * 8: å
 */
enum ESCS_ATTRIBUTE {
  ESCS_DEFAULT = 0,
  ESCS_HILIGHT = 1,
  ESCS_VLINE = 2,
  ESCS_ULINE = 4,
  ESCS_BLINK = 5,
  ESCS_REVERSE = 7,
  ESCS_SECRET = 8,
};

/* ȥӥ塼 set attribute */
static void att(int att)
{
  printf("\x1b[%dm", att);
}

/*
 * ISO 6429
 * 0: 
 * 1: 
 * 2: 
 * 3: 
 * 4: 
 * 5: ޥ
 * 6: 
 * 7: 
 */
enum ESCS_COLOR {
  ESCS_BLACK,
  ESCS_RED,
  ESCS_GREEN,
  ESCS_YELLOW,
  ESCS_BLUE,
  ESCS_MAGENTA,
  ESCS_CYAN,
  ESCS_WHITE,
};

/* ʸ⡼ set foreground color */
static void col(int col)
{
  printf("\x1b[%dm", 30+col);
}

/* طʿ⡼ set background color */
static void bkcol(int col)
{
  printf("\x1b[%dm", 40+col);
}

#endif
