/*
 * regular expression pattern matching routines < rege.h >
 *
 * ɽˤѥޥå󥰥롼
 *
 * Copyright 1996,1998 (c) Taiji Yamada, AIHARA Electrical Engineering Co.,Ltd.
 */
#ifndef _REGE_H_
#define _REGE_H_

/*
 * ʸε§ɽޥ
 */
typedef unsigned long rege_syntax_t;

#define REGE_BS_BRACES           (1<<0) /* \{\} 򷫤֤Ȥ */
#define REGE_BS_PARENS           (1<<1) /* \(\) 򥰥롼׻Ȥ */
#define REGE_BS_PLUS_QM          (1<<2) /* \+,\? ¤ӻȤ */
#define REGE_BS_VBAR             (1<<3) /* \| 򥪥ڥ졼Ȥ */
#define REGE_CONTEXT_INDEP_OPS   (1<<4) /* *,+,?,{,^,$ Ͼ˥󥫡 */ /* ! */
#define REGE_CONTEXT_INVALID_OPS (1<<5) /* *,+,?,{,^,$ ʥ󥫡ػ */ /* ! */
#define REGE_DOT_NEWLINE         (1<<6) /* . Ԥ˥ޥå */
#define REGE_DOT_NOT_NULL        (1<<7) /* . ʥʸ˥ޥåʤ */
#define REGE_IGNORE_EMPTY_RANGES (1<<8) /* [z-a] Τ褦ʥ󥸤̵ */
#define REGE_HAT_LISTS_NEWLINE   (1<<9) /* [^] ǲԤ˥ޥå */
#define REGE_IGNORE_CASE        (1<<10) /* ʸʸ̤ʤ */
#define REGE_LIMITED_OPS        (1<<11) /* +,?,| 󥪥ڥ졼Ȥ */
#define REGE_SMALLEST_MATCH     (1<<12) /* ǺûޥåԤ */ /* ! */
#define REGE_NEWLINE_ALT        (1<<13) /* Ԥ򥪥ڥ졼Ȥ */
#define REGE_NO_BS_ESC_IN_LISTS (1<<14) /* [] ǥ᥿׶ػ */
#define REGE_NO_BS_REFS         (1<<15) /* Ȥػ */ /* ! */
#define REGE_NO_INTERVALS       (1<<16) /* ֤ػ */
#define REGE_NO_MATCH_BOL       (1<<17) /* Ƭڥ졼Υޥåػ */
#define REGE_NO_MATCH_EOL       (1<<18) /* ڥ졼Υޥåػ */
#define REGE_NO_XCHAR_CLASSES   (1<<19) /* ĥ饯饹 [::] ػ */ /* ! */
#define REGE_UNMATCH_RPAREN_ORD (1<<20) /* Ω )  */ /* ! */

/*
 * ޤޤʹʸε§ΤΥӥ˥󥹥ޥ
 */
#define REGE_SYNTAX_PERL 0

#define REGE_SYNTAX_AWK \
(REGE_BS_BRACES |\
 REGE_DOT_NOT_NULL |\
 REGE_HAT_LISTS_NEWLINE |\
 REGE_NO_BS_ESC_IN_LISTS |\
 REGE_NO_BS_REFS |\
 REGE_NO_INTERVALS |\
 REGE_NO_XCHAR_CLASSES |\
 REGE_UNMATCH_RPAREN_ORD)

#define REGE_SYNTAX_POSIX_AWK \
(REGE_CONTEXT_INDEP_OPS |\
 REGE_DOT_NEWLINE |\
 REGE_DOT_NOT_NULL |\
 REGE_HAT_LISTS_NEWLINE |\
 REGE_UNMATCH_RPAREN_ORD)

#define REGE_SYNTAX_GREP \
(REGE_BS_BRACES |\
 REGE_BS_PARENS |\
 REGE_BS_PLUS_QM |\
 REGE_BS_VBAR |\
 REGE_IGNORE_EMPTY_RANGES |\
 REGE_NEWLINE_ALT |\
 REGE_NO_BS_ESC_IN_LISTS)

#define REGE_SYNTAX_EGREP \
(REGE_BS_BRACES |\
 REGE_CONTEXT_INDEP_OPS |\
 REGE_IGNORE_EMPTY_RANGES |\
 REGE_NEWLINE_ALT |\
 REGE_NO_BS_ESC_IN_LISTS |\
 REGE_NO_INTERVALS)

#define REGE_SYNTAX_POSIX_EGREP \
(REGE_CONTEXT_INDEP_OPS |\
 REGE_IGNORE_EMPTY_RANGES |\
 REGE_NEWLINE_ALT |\
 REGE_NO_BS_ESC_IN_LISTS)

#define REGE_SYNTAX_ED REGE_SYNTAX_POSIX_BASIC

#define REGE_SYNTAX_SED REGE_SYNTAX_POSIX_BASIC

#define REGE_SYNTAX_POSIX_BASIC \
(REGE_BS_BRACES |\
 REGE_BS_PARENS |\
 REGE_BS_PLUS_QM |\
 REGE_BS_VBAR |\
 REGE_DOT_NEWLINE |\
 REGE_DOT_NOT_NULL |\
 REGE_HAT_LISTS_NEWLINE |\
 REGE_NO_BS_ESC_IN_LISTS)

#define REGE_SYNTAX_POSIX_EXTENDED \
(REGE_CONTEXT_INDEP_OPS |\
 REGE_DOT_NEWLINE |\
 REGE_DOT_NOT_NULL |\
 REGE_HAT_LISTS_NEWLINE |\
 REGE_NO_BS_ESC_IN_LISTS |\
 REGE_UNMATCH_RPAREN_ORD)

#define REGE_SYNTAX_EMACS \
(REGE_BS_BRACES |\
 REGE_BS_PARENS |\
 REGE_BS_VBAR |\
 REGE_IGNORE_EMPTY_RANGES |\
 REGE_HAT_LISTS_NEWLINE |\
 REGE_NO_BS_ESC_IN_LISTS |\
 REGE_NO_INTERVALS |\
 REGE_NO_XCHAR_CLASSES)

/*
 * 顼
 */
typedef enum {
  REGE_NOERROR,
  REGE_NOMATCH,
  REGE_BADPAT,
  REGE_ECOLLATE,
  REGE_ECTYPE,
  REGE_EESCAPE,
  REGE_ESUBREG,
  REGE_EBRACK,
  REGE_EPAREN,
  REGE_EBRACE,
  REGE_BADBR,
  REGE_ERANGE,
  REGE_ESPACE,
  REGE_BADRPT,
  REGE_EEND,
  REGE_ESIZE,
  REGE_ERPAREN,
} rege_errcode_t;
extern char *rege_error(rege_errcode_t errcode);

/*
 * ɽΥѥΤη
 */
typedef struct {
  rege_syntax_t syntax;         /* ʸ§ */
  rege_errcode_t errcode;       /* 顼 */
  char *trans_table;            /* Ѵɽ */
  void *buffer;                 /* ѥ륤᡼ */
} rege_t;

/*
 * ɽ򥳥ѥ
 */
extern rege_t *rege_compile(char *pattern, rege_syntax_t syntax, char *trans_table);

/*
 * ʸ string Фƥѥޥå󥰤Ԥʤ
 */
extern void rege_match(rege_t *rege, char *string, size_t size, char **from, char **to);

/*
 * ʸ string Фƥѥޥå󥰤Ԥʤ '^', '$' ̵
 */
extern void rege_next_match(rege_t *rege, char *string, size_t size, char **from, char **to);

/*
 * ɽΥѥΤη
 */
extern void rege_free(rege_t *rege);

#endif /* _REGE_H_ */
